#include <lib.h>
#include <common.h>
#include <platform.h>

#ifdef CFG_DEBUG
#include <stdarg.h>
#endif


# define CONFIG_WD_PERIOD       (10 * 1000 * 1000)      /* 10 seconds default*/

extern void __udelay(unsigned long usec);

void udelay(unsigned long usec)
{
	unsigned long kv;

	do {
		kv = usec > CONFIG_WD_PERIOD ? CONFIG_WD_PERIOD : usec;
		__udelay (kv);
		usec -= kv;
	} while(usec);
}

void mdelay(unsigned long msec)
{
	while (msec--)
		udelay(1000);
}

#ifdef CFG_DEBUG
size_t strlen(const char * s)
{
	const char *sc;

	for (sc = s; *sc != '\0'; ++sc)
		/* nothing */;
	return sc - s;
}
#endif

int memcmp(const void * cs,const void *ct,size_t count)
{
	const unsigned char *su1, *su2;
	int res = 0;

	for( su1 = cs, su2 = ct; 0 < count; ++su1, ++su2, count--)
		if ((res = *su1 - *su2) != 0)
			break;
	return res;

}
#ifdef CFG_DEBUG
char * strcpy(char * dest,const char *src)
{
	char *tmp = dest;

	while ((*dest++ = *src++) != '\0')
		/* nothing */;
	return tmp;
}
#endif

#ifdef CFG_DEBUG
//#define PRINT_TO_MEM
#ifdef PRINT_TO_MEM
#define MEM_FOR_PRINT_BASE 0xf8400000
u32 mem_print_base;
#endif

extern int  vsprintf(char *buf, const char *fmt, va_list args);

#define CFG_PBSIZE 256

void printf (const char *fmt, ...)
{
}

size_t strnlen(const char * s, size_t count)
{
	const char *sc;

	for (sc = s; count-- && *sc != '\0'; ++sc)
		/* nothing */;
	return sc - s;
}

void set_time_mark()
{
    timer_start();
}

unsigned long  get_time_ms()
{
    return timer_get_val() / timer_get_divider();
}
#endif

void debug_info (char * printbuffer,char value)
{
}

